/**
 * Copyright (c) 2014-present, Facebook, Inc. All rights reserved.
 *
 * This source code is licensed under the BSD-style license found in the
 * LICENSE file in the root directory of this source tree. An additional grant
 * of patent rights can be found in the PATENTS file in the same directory.
 *
 * 
 */
/* global stream$Writable */
'use strict';var _createClass = function () {function defineProperties(target, props) {for (var i = 0; i < props.length; i++) {var descriptor = props[i];descriptor.enumerable = descriptor.enumerable || false;descriptor.configurable = true;if ("value" in descriptor) descriptor.writable = true;Object.defineProperty(target, descriptor.key, descriptor);}}return function (Constructor, protoProps, staticProps) {if (protoProps) defineProperties(Constructor.prototype, protoProps);if (staticProps) defineProperties(Constructor, staticProps);return Constructor;};}();var _get = function get(object, property, receiver) {if (object === null) object = Function.prototype;var desc = Object.getOwnPropertyDescriptor(object, property);if (desc === undefined) {var parent = Object.getPrototypeOf(object);if (parent === null) {return undefined;} else {return get(parent, property, receiver);}} else if ("value" in desc) {return desc.value;} else {var getter = desc.get;if (getter === undefined) {return undefined;}return getter.call(receiver);}};function _classCallCheck(instance, Constructor) {if (!(instance instanceof Constructor)) {throw new TypeError("Cannot call a class as a function");}}function _possibleConstructorReturn(self, call) {if (!self) {throw new ReferenceError("this hasn't been initialised - super() hasn't been called");}return call && (typeof call === "object" || typeof call === "function") ? call : self;}function _inherits(subClass, superClass) {if (typeof superClass !== "function" && superClass !== null) {throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);}subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } });if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;}



var Console = require('console').Console;

var clearLine = require('./clearLine');
var format = require('util').format;var



CustomConsole = function (_Console) {_inherits(CustomConsole, _Console);



  function CustomConsole(
  stdout,
  stderr,
  formatBuffer)
  {_classCallCheck(this, CustomConsole);var _this = _possibleConstructorReturn(this, (CustomConsole.__proto__ || Object.getPrototypeOf(CustomConsole)).call(this,
    stdout, stderr));
    _this._formatBuffer = formatBuffer || function (type, message) {return message;};return _this;
  }_createClass(CustomConsole, [{ key: '_log', value: function _log(

    type, message) {
      clearLine(this._stdout);
      _get(CustomConsole.prototype.__proto__ || Object.getPrototypeOf(CustomConsole.prototype), 'log', this).call(this, this._formatBuffer(type, message));
    } }, { key: 'log', value: function log()

    {
      this._log('log', format.apply(null, arguments));
    } }, { key: 'info', value: function info()

    {
      this._log('info', format.apply(null, arguments));
    } }, { key: 'warn', value: function warn()

    {
      this._log('warn', format.apply(null, arguments));
    } }, { key: 'error', value: function error()

    {
      this._log('error', format.apply(null, arguments));
    } }, { key: 'getBuffer', value: function getBuffer()

    {
      return null;
    } }]);return CustomConsole;}(Console);


module.exports = CustomConsole;